from abc import ABC, abstractmethod

from bot_data.model.technician_config import TechnicianConfig


class TechnicianConfigRepositoryABC(ABC):
    @abstractmethod
    def __init__(self):
        pass

    @abstractmethod
    def get_technician_config(self) -> TechnicianConfig:
        pass

    @abstractmethod
    def add_technician_config(self, technician_config: TechnicianConfig):
        pass

    @abstractmethod
    def update_technician_config(self, technician_config: TechnicianConfig):
        pass

    @abstractmethod
    def delete_technician_config(self, technician_config: TechnicianConfig):
        pass
