from cpl_core.configuration.configuration_model_abc import ConfigurationModelABC
from cpl_query.extension import List


class BaseServerSettings(ConfigurationModelABC):
    def __init__(
        self,
        id: int = None,
        max_voice_state_hours: int = None,
        xp_per_message: int = None,
        xp_per_reaction: int = None,
        max_message_xp_per_hour: int = None,
        xp_per_ontime_hour: int = None,
        xp_per_event_participation: int = None,
        xp_per_achievement: int = None,
        afk_channel_ids: List = None,
        afk_command_channel_id: int = None,
        help_command_reference_url: str = None,
        help_voice_channel_id: int = None,
        team_channel_id: int = None,
        ping_urls: list = None,
    ):
        ConfigurationModelABC.__init__(self)

        self._id = 0 if id is None else id
        self._max_voice_state_hours = 0 if max_voice_state_hours is None else max_voice_state_hours
        self._xp_per_message = 0 if xp_per_message is None else xp_per_message
        self._xp_per_reaction = 0 if xp_per_reaction is None else xp_per_reaction
        self._max_message_xp_per_hour = 0 if max_message_xp_per_hour is None else max_message_xp_per_hour
        self._xp_per_ontime_hour = 0 if xp_per_ontime_hour is None else xp_per_ontime_hour
        self._xp_per_event_participation = 0 if xp_per_event_participation is None else xp_per_event_participation
        self._xp_per_achievement = 0 if xp_per_achievement is None else xp_per_achievement
        self._afk_channel_ids = List(int) if afk_channel_ids is None else List(int, afk_channel_ids)
        self._afk_command_channel_id = 0 if afk_command_channel_id is None else afk_command_channel_id
        self._help_command_reference_url = "" if help_command_reference_url is None else help_command_reference_url
        self._help_voice_channel_id = 0 if help_voice_channel_id is None else help_voice_channel_id
        self._team_channel_id = 0 if team_channel_id is None else team_channel_id
        self._ping_urls = List(str) if ping_urls is None else List(str, ping_urls)

    @property
    def id(self) -> int:
        return self._id

    @property
    def max_voice_state_hours(self) -> int:
        return self._max_voice_state_hours

    @property
    def xp_per_message(self) -> int:
        return self._xp_per_message

    @property
    def xp_per_reaction(self) -> int:
        return self._xp_per_reaction

    @property
    def max_message_xp_per_hour(self) -> int:
        return self._max_message_xp_per_hour

    @property
    def xp_per_ontime_hour(self) -> int:
        return self._xp_per_ontime_hour

    @property
    def xp_per_event_participation(self) -> int:
        return self._xp_per_event_participation

    @property
    def xp_per_achievement(self) -> int:
        return self._xp_per_achievement

    @property
    def afk_channel_ids(self) -> List[int]:
        return self._afk_channel_ids

    @property
    def afk_command_channel_id(self) -> int:
        return self._afk_command_channel_id

    @property
    def help_command_reference_url(self) -> str:
        return self._help_command_reference_url

    @property
    def team_channel_id(self) -> int:
        return self._team_channel_id

    @property
    def help_voice_channel_id(self) -> int:
        return self._help_voice_channel_id

    @property
    def ping_urls(self) -> List[str]:
        return self._ping_urls
